﻿using ArcGIS.Core.CIM;
using ArcGIS.Core.Data;
using ArcGIS.Core.Geometry;
using ArcGIS.Desktop.Catalog;
using ArcGIS.Desktop.Core;
using ArcGIS.Desktop.Editing;
using ArcGIS.Desktop.Editing.Attributes;
using ArcGIS.Desktop.Extensions;
using ArcGIS.Desktop.Framework;
using ArcGIS.Desktop.Framework.Contracts;
using ArcGIS.Desktop.Framework.Dialogs;
using ArcGIS.Desktop.Framework.Threading.Tasks;
using ArcGIS.Desktop.Layouts;
using ArcGIS.Desktop.Mapping;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Editing_1_Examples.Demo1
{
  internal class EditOperationBasic1 : Button
  {
    protected override void OnClick()
    {
      var fac_point_lyr = MapView.Active.Map.GetLayersAsFlattenedList().First(
        l => l.Name == "FacilitySitePoint1") as FeatureLayer;

      var fac_poly_lyr = MapView.Active.Map.GetLayersAsFlattenedList().First(
        l => l.Name == "FacilitySite1") as FeatureLayer;

      //Add and modify some features
      QueuedTask.Run(() =>
      {
        //Init
        //Get facility poly...
        var poly_oid = fac_poly_lyr.Select().GetObjectIDs().First();

        //Get an arbitrary point location to use in the edit operation
        var insp = new Inspector();
        insp.Load(fac_poly_lyr, poly_oid);
        var boundary = insp["SHAPE"] as Polygon;

        var label_pt = GeometryEngine.Instance.LabelPoint(boundary);
        var dist_x = boundary.Length / 100.0;



        // create edit operation
        var editOp = new EditOperation()
        {
          Name = "Basic Workflow",
          ErrorMessage = "'Basic Workflow' failed",
          SelectModifiedFeatures = true
        };

        //Add two points
        editOp.Create(fac_point_lyr, label_pt);
        editOp.Create(fac_point_lyr, GeometryEngine.Instance.Move(
          label_pt, dist_x, 0.0));

        double bufferDistance = boundary.Length / 25.0;
        //Modify the facility site polygon
        editOp.Modify(fac_poly_lyr, poly_oid,
          GeometryEngine.Instance.Buffer(boundary, bufferDistance));

        //Execute the operations
        editOp.Execute();
      });
    }
  }
}
