﻿using ArcGIS.Core.CIM;
using ArcGIS.Core.Data;
using ArcGIS.Core.Geometry;
using ArcGIS.Desktop.Catalog;
using ArcGIS.Desktop.Core;
using ArcGIS.Desktop.Editing;
using ArcGIS.Desktop.Editing.Attributes;
using ArcGIS.Desktop.Extensions;
using ArcGIS.Desktop.Framework;
using ArcGIS.Desktop.Framework.Contracts;
using ArcGIS.Desktop.Framework.Dialogs;
using ArcGIS.Desktop.Framework.Threading.Tasks;
using ArcGIS.Desktop.Layouts;
using ArcGIS.Desktop.Mapping;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Editing_1_Examples.Demo1
{
  internal class InspectorBasic2 : Button
  {
		protected async override void OnClick()
		{
			var fac_point_lyr = MapView.Active.Map.GetLayersAsFlattenedList()
				.First(l => l.Name == "FacilitySitePoint1") as FeatureLayer;

			await QueuedTask.Run(() =>
			{
				var point_oid = fac_point_lyr.Select().GetObjectIDs().Last();
				fac_point_lyr.ClearSelection();

				var inspector = new Inspector();
				inspector.Load(fac_point_lyr, point_oid);

				inspector["FACILITYID"] = "99999.00";
				inspector["NAME"] = "BLDG 99";
				inspector["FACAREA"] = 99999;

				var editOp = new EditOperation()
				{
					Name = $"Modify Facility Point {point_oid}",
					CancelMessage = "Modify Facility Point canceled",
					SelectModifiedFeatures = true
				};
				//editOp.Clip(...)
				//editOp.Delete(...)
				editOp.Modify(inspector);
				editOp.Execute();
			});

		}
	}
}
