﻿using ArcGIS.Core.CIM;
using ArcGIS.Core.Data;
using ArcGIS.Core.Geometry;
using ArcGIS.Desktop.Catalog;
using ArcGIS.Desktop.Core;
using ArcGIS.Desktop.Editing;
using ArcGIS.Desktop.Editing.Attributes;
using ArcGIS.Desktop.Extensions;
using ArcGIS.Desktop.Framework;
using ArcGIS.Desktop.Framework.Contracts;
using ArcGIS.Desktop.Framework.Dialogs;
using ArcGIS.Desktop.Framework.Threading.Tasks;
using ArcGIS.Desktop.Layouts;
using ArcGIS.Desktop.Mapping;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Editing_1_Examples.Demo1
{
  internal class InspectorBasic3 : Button
  {
		protected async override void OnClick()
		{
			var fac_point_lyr = MapView.Active.Map.GetLayersAsFlattenedList()
				.First(l => l.Name == "FacilitySitePoint1") as FeatureLayer;
			var fac_poly_lyr = MapView.Active.Map.GetLayersAsFlattenedList()
				.First(l => l.Name == "FacilitySite1") as FeatureLayer;

			await QueuedTask.Run(() =>
			{
				var oids = fac_point_lyr.Select().GetObjectIDs();
				fac_point_lyr.ClearSelection();
				var point_oid = oids.Last();
				var label_pt = Module1.Current.GetBoundaryLabelPoint(fac_poly_lyr);



				var editOp = new EditOperation()
				{
					Name = "Copy/Duplicate Feature",
					CancelMessage = "Copy/Duplicate Feature cancelled",
					SelectNewFeatures = true,
					SelectModifiedFeatures = true
				};

				var inspector = new Inspector();
				inspector.Load(fac_point_lyr, point_oid);

				inspector["FACILITYID"] = "99999.00";//modify attributes, if/as needed
				inspector["NAME"] = "BLDG 99";
				inspector["FACAREA"] = 99999;
				inspector.Shape = label_pt;

				editOp.Create(inspector.MapMember, inspector);

				var point_oid2 = oids[2];
				//Linq ToDictionary
				var dict_copy = inspector.ToDictionary(a => a.FieldName, a => a.CurrentValue);
				dict_copy.Remove("SHAPE");//keep original location

				editOp.Modify(fac_point_lyr, point_oid2, dict_copy);

				editOp.Execute();
			});
		}
	}
}
