﻿using ArcGIS.Core.CIM;
using ArcGIS.Core.Data;
using ArcGIS.Core.Geometry;
using ArcGIS.Desktop.Catalog;
using ArcGIS.Desktop.Core;
using ArcGIS.Desktop.Editing;
using ArcGIS.Desktop.Editing.Attributes;
using ArcGIS.Desktop.Extensions;
using ArcGIS.Desktop.Framework;
using ArcGIS.Desktop.Framework.Contracts;
using ArcGIS.Desktop.Framework.Dialogs;
using ArcGIS.Desktop.Framework.Threading.Tasks;
using ArcGIS.Desktop.Layouts;
using ArcGIS.Desktop.Mapping;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Editing_1_Examples.Demo2
{
  internal class EditOperationOrdering : Button
  {
		protected override void OnClick()
		{
			var fac_poly_lyr = MapView.Active.Map.GetLayersAsFlattenedList()
											.OfType<FeatureLayer>().First(fl => fl.Name == "FacilitySite1");
			var fac_line_lyr = MapView.Active.Map.GetLayersAsFlattenedList()
											.OfType<FeatureLayer>().First(fl => fl.Name == "FacilitySiteLine");
			QueuedTask.Run(() =>
			{
				//Init
				//Get the Object ids of the features "in question"...
				var line_oid = fac_line_lyr.Select().GetObjectIDs().First();
				var poly_oid = fac_poly_lyr.Select().GetObjectIDs().First();
				fac_line_lyr.ClearSelection();
				fac_poly_lyr.ClearSelection();

				//Get the geometry of the line to use in the edit operation
				var insp = new Inspector();
				insp.Load(fac_line_lyr, line_oid);
				var split_geom = insp["SHAPE"] as Polyline;

				//Set the new attribute value
				var attrib = new Dictionary<string, object>();
				attrib["LABEL_FIELD"] = "Bar";

				var editOp = new EditOperation();

				editOp.ExecuteMode = ExecuteModeType.Default;

				editOp.Name = $"{editOp.ExecuteMode.ToString()} example";

				//Do the operation.
				editOp.Split(fac_poly_lyr, poly_oid, split_geom);
				editOp.Modify(fac_poly_lyr, poly_oid, attrib);

				editOp.Execute();
			});

		}
	}
}
